/*---------------------------------------------------------------
           FILE: corparams.h
      $Revision: 2.0 $
         $State: Exp $
  Last submitted $Date: 93/03/30 18:05:20 $ $Author: jh $

   Locked out by $Locker: jh $

  REVISION HISTORY
  $Log:	corparams.h,v $
 * Revision 2.0  93/03/30  18:05:20  jh
 * Actual first release version.
 * 

  $Source: /u3/jh/jupobs92/anal/iraf/src/jiggle/RCS/corparams.h,v $

  Copyright (c) 1993 Joseph Harrington.
  All Rights reserved.
---------------------------------------------------------------*/
#ifndef CORPARAMS_PROTECT
#ifndef LINT
static char rcsidcorparamsh[] = "$Header: /u3/jh/jupobs92/anal/iraf/src/jiggle/RCS/corparams.h,v 2.0 93/03/30 18:05:20 jh Exp Locker: jh $";
static char copyrightcorparamsh[] =
    "Copyright (c) 1993 Joseph Harrington.  All Rights reserved.";
#endif
#endif

/*---------------------------------------------------------------
corparams.h = include file for corparams.c

---------------------------------------------------------------*/
#ifndef CORPARAMS_PROTECT
#define CORPARAMS_PROTECT

/* definitions */
#define SUCCESS 1
#define FAILURE 0
#define TRUE 1
#define FALSE 0

/* inclusions */
#include <stdio.h>
#include <stddef.h>
#include "memory.h"

/* data types */

typedef struct {
    char         a_im[FILENAME_MAX];   /* first input image */
    char         b_im[FILENAME_MAX];   /* second input image */
    char         out_im[FILENAME_MAX]; /* output image */
    double       radius;	       /* max offset from nominal overlaps */
    double       x;	               /* nominal overlaps */
    double       y;
    Doub2 * (*cor)(
                   Doub2  *a,
                   Doub2  *b,
                   double  nomx,
                   double  nomy,
                   double  radius
	    ); /* correlation function */
} Data;

/* prototypes */

#if defined(__STDC__) || defined(__cplusplus)
# define P_(s) s
#else
# define P_(s) ()
#endif


/* corparams.c */
Data *create_data P_((void));
int interp_command_line_args P_((int argc, char *argv[], Data *dat));
void usage P_((char *progname));

#undef P_

#endif
