/*---------------------------------------------------------------
           FILE: test.c
      $Revision: 2.0 $
         $State: Exp $
  Last submitted $Date: 93/03/30 18:05:00 $ $Author: jh $

   Locked out by $Locker: jh $

  REVISION HISTORY
  $Log:	simplex_test.c,v $
 * Revision 2.0  93/03/30  18:05:00  jh
 * Actual first release version.
 * 
 * Revision 1.2  93/03/30  13:54:24  jh
 * General code cleanup, testing, and added features.
 * First release version.
 * 
 * Revision 1.1  92/12/15  13:11:43  jh
 * Initial revision
 * 

  $Source: /u3/jh/jupobs92/anal/iraf/src/jiggle/RCS/simplex_test.c,v $

  Copyright (c) 1992, 1993 Joseph Harrington.
  All Rights reserved.
---------------------------------------------------------------*/
#ifndef LINT
static char rcsid[] = "$Header: /u3/jh/jupobs92/anal/iraf/src/jiggle/RCS/simplex_test.c,v 2.0 93/03/30 18:05:00 jh Exp Locker: jh $";
static char copyright[] =
    "Copyright (c) 1992 Joseph Harrington.  All Rights reserved.";
#endif
/*---------------------------------------------------------------
jiggle.c = program that tests simplex function minimizer

External object files or libraries:
simplex.c
memory.c
-lm
---------------------------------------------------------------*/
/* inclusions */

#include "simplex.h"
#include <stdio.h>
#include <stdlib.h>
#include <math.h>

/* data types */

typedef struct {
    double a;
    double b;
    double c;
    double intercept;
} Parapars;

/* prototypes */

double
paraboloid(
	   double   p[],
	   Parapars *parapars
);

/*---------------------------------------------------------------
Effect: 

Requires:

Modifies:

Implementation notes:
    good to try: simplex_test 1 1 1e-5 1 2 .5 500 >& testout
    compile simplex.c with -DDEBUG for detailed output
---------------------------------------------------------------*/
int
main(int argc, char *argv[]){
    Simplex_param *param;
    Parapars parapars;

    param = simplex_create(2);

    (void)simplex_init_param
	(param, paraboloid, &parapars,
	 atof(argv[3]),
	 atof(argv[4]), atof(argv[5]), atof(argv[6]),
	 atoi(argv[7]));

    param->p[0][0] = atof(argv[1]);
    param->p[0][1] = atof(argv[2]);

    parapars.a = 1.;
    parapars.b = 1.;
    parapars.c = 1.;
    parapars.intercept = 0.;

    (void)simplex_init_point(param, .1);

    (void)simplex(param);

    fprintf(stderr, "restart\n");
    param->funcmax *= 2;

    (void)simplex_init_point(param, .1);

    (void)simplex(param);

    return 0;
}

/*---------------------------------------------------------------
Effect:

Requires:

Modifies:

Implementation notes:
---------------------------------------------------------------*/
double
paraboloid(
	   double   p[],
	   Parapars *parapars
){
    return   parapars->a * pow(p[0],2)
	   + parapars->b * p[0] * p[1]
	   + parapars->c * pow(p[1],2)
	   + parapars->intercept;
}
